Object subclass: #Ghost
	uses: TTyped
	instanceVariableNames: '(Set<GReference>)dependencies (Symbol)gName (GClassUnity | GhostSet)container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ghosts-Core-AST'!

!Ghost methodsFor: 'ghosts-browser' stamp: 'OzC 7/10/2012 00:24'!
(Boolean) <= (Ghost) another
	^self subclassResponsibility ! !

!Ghost methodsFor: 'ghosts-browser' stamp: 'OzC 7/10/2012 00:25'!
(Array<Ghost>)children
	^self subclassResponsibility ! !

!Ghost methodsFor: 'ghosts-browser' stamp: 'OzC 7/10/2012 00:25'!
(Boolean)isBustAllowed
	^self subclassResponsibility ! !


!Ghost methodsFor: 'ghost buster' stamp: 'OzC 7/10/2012 00:25'!
(Self)bust
	^self subclassResponsibility ! !


!Ghost methodsFor: 'accessing' stamp: 'OzC 7/10/2012 16:46'!
(Self)container: (GClassUnity | GhostSet)set
	"? must be Self, but not thisSelf, the self of the structural types"
	container := set.
	! !

!Ghost methodsFor: 'accessing' stamp: 'OzC 7/10/2012 00:26'!
(Set<GReference>)dependencies
	^ dependencies! !

!Ghost methodsFor: 'accessing' stamp: 'OzC 7/10/2012 00:26'!
(Symbol)gName
	^ gName! !

!Ghost methodsFor: 'accessing' stamp: 'OzC 7/10/2012 00:26'!
(Self)gName: (Symbol) anObject
	gName := anObject! !


!Ghost methodsFor: 'as yet unclassified' stamp: 'OzC 7/10/2012 00:26'!
(Boolean)hasDependencies
	^ dependencies size > 0 ! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'OzC 7/10/2012 00:26'!
(Self)remove
	"self subclassResponsibility " ! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'OzC 7/10/2012 00:26'!
(Self)removeDepsFrom: (Symbol) selector  inClass: (ClassDescription) class 
	dependencies do: [:(GReference)dep | 
		(dep selector = selector) & ( dep classRef = class) ifTrue: [
			dependencies remove: dep]]. 
	self hasDependencies ifFalse: [self remove]   ! !


!Ghost methodsFor: 'initialization' stamp: 'OzC 7/10/2012 00:26'!
(Self) initialize 
	dependencies := Set new. ! !


!Ghost methodsFor: 'testing' stamp: 'OzC 7/10/2012 00:26'!
(Boolean)isClassUnity 
	^ false ! !

!Ghost methodsFor: 'testing' stamp: 'OzC 7/10/2012 00:26'!
(Boolean)isMethod 
	^ false ! !


!Ghost methodsFor: 'printing' stamp: 'OzC 7/10/2012 00:27'!
(String)printString
	^self subclassResponsibility ! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Ghost class
	uses: TTyped classTrait
	instanceVariableNames: ''!


Ghost subclass: #GMethod
	instanceVariableNames: '(GBehavior | ClassDescription)owner (SmallInteger)params'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ghosts-Core-AST'!
!GMethod commentStamp: 'OzC 11/29/2011 15:17' prior: 0!
owner is an union type GBehavior | ClassDescription!


!GMethod methodsFor: 'ghosts-browser' stamp: 'OzC 7/10/2012 00:33'!
(Boolean)<= (Ghost)ghost
	ghost isClassUnity ifTrue: [^ false].
	^ self asString <= ghost asString  ! !

!GMethod methodsFor: 'ghosts-browser' stamp: 'OzC 7/10/2012 00:34'!
(Array<Ghost>)children 
	^ #()! !

!GMethod methodsFor: 'ghosts-browser' stamp: 'OzC 11/29/2011 15:14'!
(Boolean)isBustAllowed 
	^ self isExtensionMethod ! !


!GMethod methodsFor: 'ghost buster' stamp: 'OzC 11/29/2011 15:17'!
(String)asSource 
	^ self methodNameDeclaration , '
	self flag: #GhostBusted'.! !

!GMethod methodsFor: 'ghost buster' stamp: 'OzC 7/10/2012 16:50'!
(Self)bust
	(self isExtensionMethod ) ifFalse: [self error: 'Busted is not allowed, when the owner is a ghost in ', self asString].
	
	(<ClassDescription>owner) compile: self asSource classified: 'ghost-busted'. 
	
	self remove  ! !

!GMethod methodsFor: 'ghost buster' stamp: 'OzC 7/10/2012 00:34'!
(String)methodNameDeclaration
	|(SmallInteger)c| 
	params = 0 ifTrue: [^ gName].
	params = 1 ifTrue: [^ gName, ' t'].
	c:=0.  
	^ (gName  subStrings: ':') inject: '' into: [:(String)acc :(String)next| acc , (next,': t', (c:=c+1) asString ), ' '] ! !


!GMethod methodsFor: 'testing' stamp: 'OzC 11/29/2011 15:16'!
(Boolean)isExtensionMethod 
	^ owner isBehavior  ! !


!GMethod methodsFor: 'accessing' stamp: 'OzC 11/29/2011 15:18'!
(True)isMethod 
	^ true! !

!GMethod methodsFor: 'accessing' stamp: 'OzC 11/29/2011 15:18'!
owner
	^ owner! !

!GMethod methodsFor: 'accessing' stamp: 'OzC 11/9/2011 19:59'!
owner: ghost
	owner := ghost.
	(self isExtensionMethod) ifFalse: [
		ghost methDict at: self selector put: self.]
	
	! !

!GMethod methodsFor: 'accessing' stamp: 'OzC 11/29/2011 15:19'!
(Self)params: (SmallInteger)size
	params := size! !

!GMethod methodsFor: 'accessing' stamp: 'OzC 11/29/2011 15:20'!
(String)selector "Here I know that gName is Symbol not a String. But it doesnt typecheck"
	^ gName! !

!GMethod methodsFor: 'accessing' stamp: 'OzC 11/29/2011 15:19'!
(Self)selector: (Symbol)anObject
	gName := anObject! !


!GMethod methodsFor: 'printing' stamp: 'OzC 11/29/2011 15:20'!
(String)printString 
	^ (self isExtensionMethod ifTrue: [owner asString , '>>'] ifFalse: ['']) , self selector .! !


!GMethod methodsFor: 'as yet unclassified' stamp: 'OzC 7/10/2012 16:49'!
(Self)remove
	(<{remove: (GMethod->?)}>container) remove: self.! !


Ghost subclass: #GClassUnity
	instanceVariableNames: '(GClass)gclass (GMetaclass)gmetacls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ghosts-Core-AST'!

!GClassUnity methodsFor: 'ghosts-browser' stamp: 'OzC 11/29/2011 15:00'!
(Boolean)<= (Ghost) ghost
	ghost isMethod ifTrue: [^ true].
	^ self asString <= ghost asString ! !

!GClassUnity methodsFor: 'ghosts-browser' stamp: 'OzC 7/10/2012 00:35'!
(Array<GBehavior>)children 
	^ { gclass . gmetacls }! !

!GClassUnity methodsFor: 'ghosts-browser' stamp: 'OzC 11/29/2011 15:01'!
(True)isBustAllowed
	^ true! !


!GClassUnity methodsFor: 'ghost buster' stamp: 'OzC 7/10/2012 16:44'!
(Self)bust
	gclass bust.
	gmetacls bust.
	(<GhostSet>container) remove: self.! !


!GClassUnity methodsFor: 'as yet unclassified' stamp: 'OzC 7/10/2012 00:35'!
(String)category 
	|(SmallDictionary)ctgs (GReference -> String)nameBlk (SmallInteger)max (String)maxCtg|
	nameBlk := [:(GReference)dep | (dep classRef category subStrings: '-') first].
	ctgs:=((OrderedCollection newFrom: (gclass dependencies collect: nameBlk)) 
			union: (gmetacls dependencies collect: nameBlk)) 
				inject: SmallDictionary new into: [:(SmallDictionary)dic :(String)ctg| |n|
					n:= dic at: ctg ifAbsentPut: [0].
					dic at: ctg put: n+1.
					dic].
	max := 0.
	ctgs keysAndValuesDo: [:(String)k :(SmallInteger)v | 
		v > max ifTrue: [maxCtg:= k . max := v]].
	^ maxCtg,'-GhostBusted'. 
			
	
	! !

!GClassUnity methodsFor: 'as yet unclassified' stamp: 'OzC 11/29/2011 15:07'!
(String)printString 
	^ gName! !

!GClassUnity methodsFor: 'as yet unclassified' stamp: 'OzC 7/10/2012 16:45'!
(Self)remove 
	(<GhostSet>container) remove: self.  ! !

!GClassUnity methodsFor: 'as yet unclassified' stamp: 'OzC 7/10/2012 00:36'!
(Self)removeDepsFrom: (Symbol)selector  inClass: (ClassDescription)class 
	gclass removeDepsFrom: selector inClass: class.
	gmetacls removeDepsFrom: selector  inClass: class.
	super removeDepsFrom: selector inClass: class. ! !


!GClassUnity methodsFor: 'accessing' stamp: 'OzC 7/10/2012 16:43'!
(Self)gName: (Symbol)name
	super gName: name.
	gclass gName: name.
	gmetacls gName: name.! !

!GClassUnity methodsFor: 'accessing' stamp: 'OzC 11/29/2011 15:09'!
(GClass)gclass
	^ gclass! !

!GClassUnity methodsFor: 'accessing' stamp: 'OzC 11/29/2011 15:10'!
(GMetaclass)gmetacls
	^ gmetacls! !


!GClassUnity methodsFor: 'testing' stamp: 'OzC 7/10/2012 00:35'!
(Boolean)hasDependencies 
	^ gclass hasDependencies or: [gmetacls hasDependencies] ! !

!GClassUnity methodsFor: 'testing' stamp: 'OzC 11/29/2011 15:10'!
(True)isClassUnity 
	^ true	! !


!GClassUnity methodsFor: 'initialization' stamp: 'OzC 11/29/2011 15:11'!
(Self)initialize
	super initialize . 
	gclass := GClass new container: self.
	gmetacls := GMetaclass new container: self. ! !


Object subclass: #GhostSet
	uses: TTyped
	instanceVariableNames: '(Dictionary<Symbol, Ghost>)ghosts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ghosts-Core-AST'!

!GhostSet methodsFor: 'ghost buster' stamp: 'OzC 11/29/2011 15:23'!
(Self)bust
	ghosts valuesDo: #bust
	"ghosts removeAll ."
	! !


!GhostSet methodsFor: 'ghosts-browser' stamp: 'OzC 11/29/2011 15:23'!
(Array)children 
	^  ghosts values sorted! !


!GhostSet methodsFor: 'accessing' stamp: 'OzC 11/29/2011 15:23'!
(GClassUnity)clsUnityNamed: (String)name
	^ ghosts at: name asSymbol ifAbsentPut: [GClassUnity new container: self ; gName: name]! !

!GhostSet methodsFor: 'accessing' stamp: 'OzC 11/29/2011 15:25'!
(GClass)gclsNamed: (String)name
	^ (self clsUnityNamed: name) gclass! !

!GhostSet methodsFor: 'accessing' stamp: 'OzC 11/29/2011 15:24'!
(Dictionary)ghosts
	^ ghosts! !

!GhostSet methodsFor: 'accessing' stamp: 'OzC 11/29/2011 15:24'!
(GMetaclass)gmclsNamed: (String)name
	^ (self clsUnityNamed: name) gmetacls ! !

!GhostSet methodsFor: 'accessing' stamp: 'OzC 11/29/2011 15:25'!
(GMethod)gmthNamed: (String)name
	^ ghosts at: name asSymbol ifAbsentPut: [GMethod new selector:  name ; container: self]! !


!GhostSet methodsFor: 'initialization' stamp: 'OzC 11/29/2011 15:30'!
(Self)initialize 
	ghosts:= Dictionary new.! !


!GhostSet methodsFor: 'testing' stamp: 'OzC 11/29/2011 15:30'!
(False)isClass
	^ false	! !

!GhostSet methodsFor: 'testing' stamp: 'OzC 11/29/2011 15:30'!
(False)isClassUnity 
	^ false	! !

!GhostSet methodsFor: 'testing' stamp: 'OzC 11/29/2011 15:30'!
(False)isMetaclass
	^ false	! !

!GhostSet methodsFor: 'testing' stamp: 'OzC 11/29/2011 15:31'!
(False)isMethod
	^ false! !


!GhostSet methodsFor: 'printing' stamp: 'OzC 11/29/2011 15:31'!
(String)printString 
	^ ghosts size asString ,' ghosts'! !


!GhostSet methodsFor: 'actions' stamp: 'OzC 11/29/2011 15:33'!
(Self)remove: (Ghost)ghost
	self ghosts removeKey: ghost gName! !

!GhostSet methodsFor: 'actions' stamp: 'OzC 11/30/2011 12:01'!
(Self)removeDepsFrom: (Symbol)selector  inClass: (ClassDescription)class
	ghosts valuesDo: [:(Ghost)ghost| ghost removeDepsFrom: selector inClass: class]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GhostSet class
	uses: TTyped classTrait
	instanceVariableNames: ''!


Ghost subclass: #GBehavior
	instanceVariableNames: '(GBehavior | Behavior)superClass (Dictionary<Symbol, GMethod>)methDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ghosts-Core-AST'!
!GBehavior commentStamp: 'OzC 11/29/2011 14:51' prior: 0!
superClass is an union type (GBehavior | ClassDescription)!


!GBehavior methodsFor: 'ghost buster' stamp: 'OzC 7/10/2012 00:27'!
(Self)bust
	|(ClassDescription)cls|
	cls := self bustEmptyClass.
	self changeMembersOwnerTo: cls.
	self bustMethods	 ! !

!GBehavior methodsFor: 'ghost buster' stamp: 'OzC 7/10/2012 00:27'!
(ClassDescription)bustEmptyClass.
	^self subclassResponsibility ! !

!GBehavior methodsFor: 'ghost buster' stamp: 'OzC 7/10/2012 00:28'!
(Self)bustMethods 
	self methDict valuesDo: #bust.
	"self methDict removeAll." 
	! !

!GBehavior methodsFor: 'ghost buster' stamp: 'OzC 7/10/2012 00:28'!
(Self)changeMembersOwnerTo: (ClassDescription)cls
	self methDict valuesDo: [:(GMethod)mth | mth owner: cls]. ! !


!GBehavior methodsFor: 'ghosts-browser' stamp: 'OzC 7/10/2012 00:28'!
(Array<Ghost>)children 
	^ methDict values sorted.
	
	 
	! !

!GBehavior methodsFor: 'ghosts-browser' stamp: 'OzC 7/10/2012 00:28'!
(False)isBustAllowed
	^ false ! !


!GBehavior methodsFor: 'accessing' stamp: 'OzC 11/29/2011 14:31'!
(GMethod)gmthNamed: (Symbol) selector 
	^ methDict at: selector ifAbsentPut: [GMethod new selector: selector ; owner: self ; container: self.]   ! !

!GBehavior methodsFor: 'accessing' stamp: 'OzC 7/10/2012 00:29'!
(Dictionary<Symbol, GMethod>) methDict
	^ methDict! !

!GBehavior methodsFor: 'accessing' stamp: 'OzC 7/10/2012 00:29'!
(Behavior | GBehavior )superClass
	^ superClass! !

!GBehavior methodsFor: 'accessing' stamp: 'OzC 7/10/2012 00:30'!
(Self)superClass: (Behavior | GBehavior )anObject
	superClass := anObject! !


!GBehavior methodsFor: 'testing' stamp: 'OzC 7/10/2012 00:30'!
(Boolean)hasDependencies 
	^ super hasDependencies or: [ 
		methDict valuesDo: [ :(GMethod)mth | 
			mth hasDependencies ifTrue: [^ true]].
		false] ! !

!GBehavior methodsFor: 'testing' stamp: 'OzC 7/10/2012 00:30'!
(Boolean)hasSelectorInSuper: (Symbol)selector
	^ (<Behavior>superClass) hasSelector: selector .   ! !

!GBehavior methodsFor: 'testing' stamp: 'OzC 11/29/2011 14:18'!
(Boolean)isClass 
	^ false! !

!GBehavior methodsFor: 'testing' stamp: 'OzC 11/29/2011 14:17'!
(Boolean)isMetaclass 
	^ false! !


!GBehavior methodsFor: 'initialization' stamp: 'OzC 11/29/2011 12:29'!
(Self)initialize 	
	super initialize .
	methDict :=  Dictionary new.! !


!GBehavior methodsFor: 'as yet unclassified' stamp: 'OzC 11/29/2011 12:35'!
(Self)remove: (GMethod)gmth
	methDict removeKey: gmth selector! !

!GBehavior methodsFor: 'as yet unclassified' stamp: 'OzC 7/10/2012 00:30'!
(Self)removeDepsFrom: (Symbol)selector  inClass: (ClassDescription) class  
	methDict valuesDo: [:(GMethod)mth | mth removeDepsFrom: selector inClass: class].
	super removeDepsFrom: selector inClass: class. 
	
	! !


GBehavior subclass: #GMetaclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ghosts-Core-AST'!

!GMetaclass methodsFor: 'ghost buster' stamp: 'OzC 11/29/2011 15:13'!
(Metaclass)bustEmptyClass 
	^ (Smalltalk at: gName asSymbol) class.	! !


!GMetaclass methodsFor: 'as yet unclassified' stamp: 'OzC 11/29/2011 15:13'!
(Self)initialize 
	super initialize .
	superClass := Object class.! !

!GMetaclass methodsFor: 'as yet unclassified' stamp: 'OzC 11/29/2011 15:13'!
(True)isMetaclass 
	^ true! !


!GMetaclass methodsFor: 'printing' stamp: 'OzC 11/29/2011 15:14'!
(String)printString 
	^ self gName, ' class'! !


GBehavior subclass: #GClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ghosts-Core-AST'!

!GClass methodsFor: 'ghost buster' stamp: 'OzC 7/10/2012 00:33'!
(Class)bustEmptyClass	
	superClass ifNil: [self error: 'Super class is nil ', self asString].
	
	(superClass isKindOf: GClass ) ifTrue: [
		(<GClass>superClass) bust.
		superClass := Smalltalk at: (<GClass>superClass) gName.].
	
	^ (<Class>superClass) subclass: gName asSymbol 
		instanceVariableNames: '' 
		classVariableNames: '' 
		poolDictionaries: '' category: ((<GClassUnity>container) category) . 
! !


!GClass methodsFor: 'as yet unclassified' stamp: 'OzC 11/29/2011 14:59'!
(Self)initialize 
	super initialize .
	superClass := Object.! !

!GClass methodsFor: 'as yet unclassified' stamp: 'OzC 11/29/2011 14:59'!
(Boolean)isClass 
	^ true! !


!GClass methodsFor: 'printing' stamp: 'OzC 11/29/2011 15:00'!
(String)printString 
	^ self gName! !
