RBProgramNodeVisitor subclass: #RBGhostsVisitor
	uses: TTyped
	instanceVariableNames: '(GhostSet)gset (ClassDescription)classRef'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ghosts-Core-Visitor'!

!RBGhostsVisitor methodsFor: 'visitor-double dispatching' stamp: 'OzC 7/9/2012 23:42'!
(Self)acceptAssignmentNode: (RBAssignmentNode)anAssignmentNode 
	|(Ghost)ghost|
	super acceptAssignmentNode: anAssignmentNode.

	ghost:= anAssignmentNode value ghostBinding ifNil: [^ self].
	
	anAssignmentNode variable variableBinding node ghostBinding:  ghost.  
	
	
	
	
	! !

!RBGhostsVisitor methodsFor: 'visitor-double dispatching' stamp: 'OzC 7/9/2012 23:44'!
(Self)acceptCascadeNode: (RBCascadeNode)aCascadeNode 
	|(Ghost)ghost|
	"aCascadeNode messages do: [:each | self visitNode: each]"
	super acceptCascadeNode: aCascadeNode .
	ghost:= aCascadeNode messages last ghostBinding ifNil: [^ self].
	aCascadeNode ghostBinding: ghost.  ! !

!RBGhostsVisitor methodsFor: 'visitor-double dispatching' stamp: 'OzC 7/9/2012 23:47'!
(Self)acceptMessageNode: (RBMessageNode) aMessageNode 
	|(GBehavior)ghost (GMethod)gmth|
	super acceptMessageNode: aMessageNode . 
	
	aMessageNode receiver isVariable ifTrue: [|(RBVariableBinding)varBinding|
		varBinding:=aMessageNode receiver variableBinding.
		varBinding isLiteralBinding ifTrue:[ |(Class)cls|
			cls:= (<RBLiteralBinding>varBinding) binding value class.
			(cls hasSelector: aMessageNode selector) ifFalse:[
				gmth:= self gset gmthNamed: aMessageNode selector.
				gmth params: aMessageNode arguments size.
				gmth owner: cls .
				self refOf: aMessageNode with: gmth].
			^ self].
		varBinding isSelfBinding ifTrue: [|(ClassDescription)cls|
			cls:= self classRef.
			(cls hasSelector: aMessageNode selector) ifFalse:[
				gmth:= self gset gmthNamed: aMessageNode selector.
				gmth params: aMessageNode arguments size.
				gmth owner: cls .
				self refOf: aMessageNode with: gmth]. 
			^ self]
	].

	ghost:= aMessageNode receiver ghostBinding ifNil: [^self]. 
	(ghost isClass | ghost isMetaclass) ifTrue: [
		(ghost hasSelectorInSuper: aMessageNode selector) ifTrue: [
			(((aMessageNode selector = #new) | (aMessageNode selector = #basicNew))  
			& ghost isMetaclass) ifTrue: [
				aMessageNode ghostBinding: (gset gclsNamed: ghost gName)]. "self halt."
			^ self].
		
		gmth:= ghost gmthNamed: aMessageNode selector.
		gmth params: aMessageNode arguments size.
		self refOf: aMessageNode with: gmth]! !

!RBGhostsVisitor methodsFor: 'visitor-double dispatching' stamp: 'OzC 7/9/2012 23:47'!
(Self)acceptVariableNode: (RBVariableNode)aVariableNode
	|(RBLocalBinding)binding| "not sure"
	binding := aVariableNode variableBinding.
	binding isUndeclaredBinding ifTrue: [ |(String)name|
		name:= aVariableNode name.
		name isLegalClassName ifTrue:[ |(GMetaclass)ghost|
			ghost:= gset gmclsNamed: name.
			self refOf: aVariableNode with: ghost.
			aVariableNode ghostBinding: ghost.
			^ self]].
	
	binding isTemporaryBinding ifTrue: [
		aVariableNode ghostBinding: (binding node ghostBinding ifNil: [^ self])]
	
	! !


!RBGhostsVisitor methodsFor: 'accessing' stamp: 'OzC 7/9/2012 23:47'!
(ClassDescription)classRef
	^ classRef ! !

!RBGhostsVisitor methodsFor: 'accessing' stamp: 'OzC 7/9/2012 23:47'!
(Self)classRef: (ClassDescription)anObject
	classRef := anObject ! !

!RBGhostsVisitor methodsFor: 'accessing' stamp: 'OzC 7/9/2012 23:47'!
(GhostSet)gset
	^ gset ! !

!RBGhostsVisitor methodsFor: 'accessing' stamp: 'OzC 7/9/2012 23:48'!
(Self)gset: (GhostSet)anObject
	gset := anObject ! !


!RBGhostsVisitor methodsFor: 'initialization' stamp: 'OzC 7/9/2012 23:48'!
(Self)initialize 
	gset:= GhostSet new. ! !


!RBGhostsVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 7/9/2012 23:48'!
(GReference)refOf: (RBProgramNode)node with: (Ghost)ghost
	 ^ GReference new 
			classRef: classRef ;
			node: node ; 
			ghost: ghost ! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

RBGhostsVisitor class
	uses: TTyped classTrait
	instanceVariableNames: ''!
